USE [msdb]
GO

/****** Object:  Job [NAVTECHDAYS_2014_SSA_JOB]    Script Date: 02/11/2014 19:27:49 ******/
BEGIN TRANSACTION
DECLARE @ReturnCode INT
SELECT @ReturnCode = 0
/****** Object:  JobCategory [[Uncategorized (Local)]]    Script Date: 02/11/2014 19:27:49 ******/
IF NOT EXISTS (SELECT name FROM msdb.dbo.syscategories WHERE name=N'[Uncategorized (Local)]' AND category_class=1)
BEGIN
EXEC @ReturnCode = msdb.dbo.sp_add_category @class=N'JOB', @type=N'LOCAL', @name=N'[Uncategorized (Local)]'
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback

END

DECLARE @jobId BINARY(16)
EXEC @ReturnCode =  msdb.dbo.sp_add_job @job_name=N'NAVTECHDAYS_2014_SSA_JOB', 
		@enabled=1, 
		@notify_level_eventlog=0, 
		@notify_level_email=0, 
		@notify_level_netsend=0, 
		@notify_level_page=0, 
		@delete_level=0, 
		@description=N'No description available.', 
		@category_name=N'[Uncategorized (Local)]', 
		@owner_login_name=N'K2012R2SQL\Administrator', @job_id = @jobId OUTPUT
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
/****** Object:  Step [rename log files]    Script Date: 02/11/2014 19:27:49 ******/
EXEC @ReturnCode = msdb.dbo.sp_add_jobstep @job_id=@jobId, @step_name=N'rename log files', 
		@step_id=1, 
		@cmdexec_success_code=0, 
		@on_success_action=3, 
		@on_success_step_id=0, 
		@on_fail_action=3, 
		@on_fail_step_id=0, 
		@retry_attempts=0, 
		@retry_interval=0, 
		@os_run_priority=0, @subsystem=N'CmdExec', 
		@command=N'C:\NAVTECHDAYS2014\RENAMELOG.cmd', 
		@flags=32
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
/****** Object:  Step [Check DB Integrity all DB]    Script Date: 02/11/2014 19:27:49 ******/
EXEC @ReturnCode = msdb.dbo.sp_add_jobstep @job_id=@jobId, @step_name=N'Check DB Integrity all DB', 
		@step_id=2, 
		@cmdexec_success_code=0, 
		@on_success_action=3, 
		@on_success_step_id=0, 
		@on_fail_action=2, 
		@on_fail_step_id=0, 
		@retry_attempts=0, 
		@retry_interval=0, 
		@os_run_priority=0, @subsystem=N'TSQL', 
		@command=N'DBCC CHECKDB(N''master'') WITH ALL_ERRORMSGS,tableresults,NO_INFOMSGS;
DBCC CHECKDB(N''model'') WITH ALL_ERRORMSGS,tableresults,NO_INFOMSGS;
DBCC CHECKDB(N''msdb'') WITH ALL_ERRORMSGS,tableresults,NO_INFOMSGS;

DBCC CHECKDB(N''BACKUP_RESTORE'') WITH ALL_ERRORMSGS,tableresults,NO_INFOMSGS;
', 
		@database_name=N'master', 
		@output_file_name=N'I:\SQLLOG\log.txt', 
		@flags=6
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
/****** Object:  Step [Rebuild only the indexes that need rebuilding]    Script Date: 02/11/2014 19:27:49 ******/
EXEC @ReturnCode = msdb.dbo.sp_add_jobstep @job_id=@jobId, @step_name=N'Rebuild only the indexes that need rebuilding', 
		@step_id=3, 
		@cmdexec_success_code=0, 
		@on_success_action=3, 
		@on_success_step_id=0, 
		@on_fail_action=2, 
		@on_fail_step_id=0, 
		@retry_attempts=0, 
		@retry_interval=0, 
		@os_run_priority=0, @subsystem=N'TSQL', 
		@command=N'DECLARE @objectid int;
DECLARE @indexid int;
DECLARE @partitioncount bigint;
DECLARE @schemaname nvarchar(130); 
DECLARE @objectname nvarchar(130); 
DECLARE @indexname nvarchar(130); 
DECLARE @partitionnum bigint;
DECLARE @partitions bigint;
DECLARE @command nvarchar(4000); 
-- Conditionally select tables and indexes from the sys.dm_db_index_physical_stats function 
-- and convert object and index IDs to names.
SELECT ips.object_id AS objectid,OBJECT_NAME(ips.object_id) AS ObjectName
  ,ips.index_id AS indexid
  ,(SELECT QUOTENAME(ind.name)
    FROM sys.indexes ind
    WHERE  ind.object_id = ips.object_id AND ind.index_id = ips.index_id) AS IndexName
  ,partition_number AS partitionnum,avg_fragmentation_in_percent AS frag
INTO #work_to_do
FROM sys.dm_db_index_physical_stats (DB_ID(), NULL, NULL , NULL, ''LIMITED'') AS ips
WHERE (ips.page_count > 7) AND (ips.index_id > 0) AND (ips.avg_fragmentation_in_percent > 10.0);

-- Declare the cursor for the list of partitions to be processed.
DECLARE partitions CURSOR FOR SELECT objectid,indexid,partitionnum,IndexName FROM #work_to_do ORDER by ObjectName,IndexName DESC;

-- Open the cursor.
OPEN partitions;

-- Loop through the partitions.
WHILE (1=1) BEGIN
  FETCH NEXT FROM partitions INTO @objectid, @indexid, @partitionnum,@indexname;
  IF @@FETCH_STATUS < 0 BREAK;
  
  SELECT @objectname = QUOTENAME(o.name), @schemaname = QUOTENAME(s.name)
  FROM sys.objects AS o
    JOIN sys.schemas as s ON s.schema_id = o.schema_id
  WHERE o.object_id = @objectid;
  
  SELECT @partitioncount = count (*)
  FROM sys.partitions
  WHERE object_id = @objectid AND index_id = @indexid;

  SET @command = 
    N''SET QUOTED_IDENTIFIER ON;'' +
    N'' ALTER INDEX '' + @indexname + N'' ON '' + N''['' + DB_NAME() + N''].'' + @schemaname + N''.'' + @objectname + N'' REBUILD WITH (FILLFACTOR=90,MAXDOP=0);'';
  IF @partitioncount > 1
    SET @command = @command + N'' PARTITION='' + CAST(@partitionnum AS nvarchar(10));

  PRINT @command;
  EXEC (@command);
END;

-- Close and deallocate the cursor.
CLOSE partitions;
DEALLOCATE partitions;

-- Drop the temporary table.
DROP TABLE #work_to_do;
GO
', 
		@database_name=N'BACKUP_RESTORE', 
		@output_file_name=N'I:\SQLLOG\log.txt', 
		@flags=6
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
/****** Object:  Step [create missing stats]    Script Date: 02/11/2014 19:27:49 ******/
EXEC @ReturnCode = msdb.dbo.sp_add_jobstep @job_id=@jobId, @step_name=N'create missing stats', 
		@step_id=4, 
		@cmdexec_success_code=0, 
		@on_success_action=3, 
		@on_success_step_id=0, 
		@on_fail_action=2, 
		@on_fail_step_id=0, 
		@retry_attempts=0, 
		@retry_interval=0, 
		@os_run_priority=0, @subsystem=N'TSQL', 
		@command=N'EXEC sp_updatestats @resample=''resample''
GO

EXEC sp_createstats @indexonly=''indexonly'',@fullscan=''fullscan''
GO
', 
		@database_name=N'BACKUP_RESTORE', 
		@output_file_name=N'I:\SQLLOG\log.txt', 
		@flags=6
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
/****** Object:  Step [Transaction log backup after index rebuild]    Script Date: 02/11/2014 19:27:49 ******/
EXEC @ReturnCode = msdb.dbo.sp_add_jobstep @job_id=@jobId, @step_name=N'Transaction log backup after index rebuild', 
		@step_id=5, 
		@cmdexec_success_code=0, 
		@on_success_action=3, 
		@on_success_step_id=0, 
		@on_fail_action=2, 
		@on_fail_step_id=0, 
		@retry_attempts=0, 
		@retry_interval=0, 
		@os_run_priority=0, @subsystem=N'TSQL', 
		@command=N'DECLARE @dt AS VARCHAR(200);
DECLARE @file  AS VARCHAR(200);
DECLARE @subdir AS VARCHAR(200);
SET @subdir = ''I:\SQLBACKUP\'' 

--TL backup BACKUP_RESTORE
SET @dt=REPLACE(REPLACE(REPLACE(CONVERT(VARCHAR(200),GETDATE(),20),''-'',''''),'':'',''''),'' '',''_'');

SET @dt= @subdir + N''BACKUP_RESTORE_'' + @dt + ''_AFTER_REBUILD.trn'';

BACKUP LOG [BACKUP_RESTORE] 
  TO  DISK = @dt 
  WITH NOFORMAT, COMPRESSION, NOINIT,  NAME = N''BACKUP_RESTORE-Transaction Log Backup after index rebuild'', 
  SKIP, NOREWIND, NOUNLOAD,  STATS = 10
', 
		@database_name=N'master', 
		@output_file_name=N'I:\SQLLOG\log.txt', 
		@flags=6
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
/****** Object:  Step [FULL backup]    Script Date: 02/11/2014 19:27:49 ******/
EXEC @ReturnCode = msdb.dbo.sp_add_jobstep @job_id=@jobId, @step_name=N'FULL backup', 
		@step_id=6, 
		@cmdexec_success_code=0, 
		@on_success_action=3, 
		@on_success_step_id=0, 
		@on_fail_action=2, 
		@on_fail_step_id=0, 
		@retry_attempts=0, 
		@retry_interval=0, 
		@os_run_priority=0, @subsystem=N'TSQL', 
		@command=N'DECLARE @dt AS VARCHAR(30);
DECLARE @file  AS VARCHAR(200);
DECLARE @subdir AS VARCHAR(200);
SET @subdir = ''I:\SQLBACKUP\'' 

--full backup BACKUP_RESTORE
SET @dt=REPLACE(REPLACE(REPLACE(CONVERT(VARCHAR(200),GETDATE(),20),''-'',''''),'':'',''''),'' '',''_'');

SET @file = @subdir + ''BACKUP_RESTORE_'' + @dt + ''_FULL.BAK'';

BACKUP DATABASE [BACKUP_RESTORE]
  TO  DISK = @file WITH NOFORMAT, NOINIT,  
  NAME = N''BACKUP_RESTORE FULL backup'', SKIP, REWIND, NOUNLOAD,  COMPRESSION, STATS = 10

-- master
SET @dt=REPLACE(REPLACE(REPLACE(CONVERT(VARCHAR(200),GETDATE(),20),''-'',''''),'':'',''''),'' '',''_'');

SET @file = @subdir + ''master_'' + @dt + ''_FULL.BAK'';

BACKUP DATABASE [master]
  TO  DISK = @file WITH NOFORMAT, NOINIT,
  NAME = N''master FULL backup'', SKIP, REWIND, NOUNLOAD,  COMPRESSION, STATS = 10

-- msdb
SET @dt=REPLACE(REPLACE(REPLACE(CONVERT(VARCHAR(200),GETDATE(),20),''-'',''''),'':'',''''),'' '',''_'');

SET @file = @subdir + ''msdb_'' + @dt + ''_FULL.BAK'';

BACKUP DATABASE [msdb]
  TO  DISK = @file WITH NOFORMAT, NOINIT,
  NAME = N''msdb FULL backup'', SKIP, REWIND, NOUNLOAD,  COMPRESSION, STATS = 10

-- model
SET @dt=REPLACE(REPLACE(REPLACE(CONVERT(VARCHAR(200),GETDATE(),20),''-'',''''),'':'',''''),'' '',''_'');

SET @file = @subdir + ''model_'' + @dt + ''_FULL.BAK'';

BACKUP DATABASE [model] 
  TO  DISK = @file WITH NOFORMAT, NOINIT,
  NAME = N''model FULL backup'', SKIP, REWIND, NOUNLOAD,  COMPRESSION, STATS = 10
', 
		@database_name=N'master', 
		@output_file_name=N'I:\SQLLOG\log.txt', 
		@flags=6
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
/****** Object:  Step [Clean backup files]    Script Date: 02/11/2014 19:27:49 ******/
EXEC @ReturnCode = msdb.dbo.sp_add_jobstep @job_id=@jobId, @step_name=N'Clean backup files', 
		@step_id=7, 
		@cmdexec_success_code=0, 
		@on_success_action=3, 
		@on_success_step_id=0, 
		@on_fail_action=2, 
		@on_fail_step_id=0, 
		@retry_attempts=0, 
		@retry_interval=0, 
		@os_run_priority=0, @subsystem=N'PowerShell', 
		@command=N'C:\NAVTECHDAYS2014\CLEAN_UP_OLD_BACKUPFILES.PS1', 
		@database_name=N'master', 
		@output_file_name=N'I:\SQLLOG\log.txt', 
		@flags=34
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
/****** Object:  Step [Clean up history]    Script Date: 02/11/2014 19:27:49 ******/
EXEC @ReturnCode = msdb.dbo.sp_add_jobstep @job_id=@jobId, @step_name=N'Clean up history', 
		@step_id=8, 
		@cmdexec_success_code=0, 
		@on_success_action=3, 
		@on_success_step_id=0, 
		@on_fail_action=2, 
		@on_fail_step_id=0, 
		@retry_attempts=0, 
		@retry_interval=0, 
		@os_run_priority=0, @subsystem=N'TSQL', 
		@command=N'DECLARE @dt AS DATETIME=GETDATE() - 180;

EXEC msdb.dbo.sp_delete_backuphistory @dt;

EXEC msdb.dbo.sp_purge_jobhistory  @oldest_date=@dt;

EXEC msdb..sp_maintplan_delete_log null,null,@dt;

EXEC msdb.dbo.sysmail_delete_mailitems_sp @sent_before = @dt;

EXEC msdb.dbo.sysmail_delete_log_sp @logged_before = @dt;
', 
		@database_name=N'master', 
		@output_file_name=N'I:\SQLLOG\log.txt', 
		@flags=6
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
/****** Object:  Step [Clean up mails]    Script Date: 02/11/2014 19:27:49 ******/
EXEC @ReturnCode = msdb.dbo.sp_add_jobstep @job_id=@jobId, @step_name=N'Clean up mails', 
		@step_id=9, 
		@cmdexec_success_code=0, 
		@on_success_action=3, 
		@on_success_step_id=0, 
		@on_fail_action=2, 
		@on_fail_step_id=0, 
		@retry_attempts=0, 
		@retry_interval=0, 
		@os_run_priority=0, @subsystem=N'TSQL', 
		@command=N'DECLARE @dt AS DATETIME = DateAdd(dd,-180,GETDATE());

EXEC msdb.dbo.sysmail_delete_mailitems_sp @sent_before = @dt;
', 
		@database_name=N'master', 
		@output_file_name=N'I:\SQLLOG\log.txt', 
		@flags=6
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
/****** Object:  Step [Delete backup history]    Script Date: 02/11/2014 19:27:49 ******/
EXEC @ReturnCode = msdb.dbo.sp_add_jobstep @job_id=@jobId, @step_name=N'Delete backup history', 
		@step_id=10, 
		@cmdexec_success_code=0, 
		@on_success_action=3, 
		@on_success_step_id=0, 
		@on_fail_action=2, 
		@on_fail_step_id=0, 
		@retry_attempts=0, 
		@retry_interval=0, 
		@os_run_priority=0, @subsystem=N'TSQL', 
		@command=N'DECLARE @dt DATETIME = CONVERT(VARCHAR(10),DATEADD(dd,-180,GETDATE()),101);

EXEC sp_delete_backuphistory @dt;

', 
		@database_name=N'msdb', 
		@output_file_name=N'I:\SQLLOG\log.txt', 
		@flags=6
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
/****** Object:  Step [Cycle error log once a week]    Script Date: 02/11/2014 19:27:49 ******/
EXEC @ReturnCode = msdb.dbo.sp_add_jobstep @job_id=@jobId, @step_name=N'Cycle error log once a week', 
		@step_id=11, 
		@cmdexec_success_code=0, 
		@on_success_action=1, 
		@on_success_step_id=0, 
		@on_fail_action=2, 
		@on_fail_step_id=0, 
		@retry_attempts=0, 
		@retry_interval=0, 
		@os_run_priority=0, @subsystem=N'TSQL', 
		@command=N'IF DATEPART(WEEKDAY,GETDATE()) = 0 
  EXEC sp_cycle_errorlog
', 
		@database_name=N'master', 
		@output_file_name=N'I:\SQLLOG\log.txt', 
		@flags=6
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
EXEC @ReturnCode = msdb.dbo.sp_update_job @job_id = @jobId, @start_step_id = 1
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
EXEC @ReturnCode = msdb.dbo.sp_add_jobschedule @job_id=@jobId, @name=N'Once a day', 
		@enabled=1, 
		@freq_type=4, 
		@freq_interval=1, 
		@freq_subday_type=1, 
		@freq_subday_interval=0, 
		@freq_relative_interval=0, 
		@freq_recurrence_factor=0, 
		@active_start_date=20141102, 
		@active_end_date=99991231, 
		@active_start_time=220000, 
		@active_end_time=235959, 
		@schedule_uid=N'60e0edd2-d202-4203-915a-5aa170d07659'
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
EXEC @ReturnCode = msdb.dbo.sp_add_jobserver @job_id = @jobId, @server_name = N'(local)'
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
COMMIT TRANSACTION
GOTO EndSave
QuitWithRollback:
    IF (@@TRANCOUNT > 0) ROLLBACK TRANSACTION
EndSave:

GO


